/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.business;

import java.util.HashMap;
import java.util.Iterator;

/**
 * classe departement dont les employee sont organises dans un Map.
 * exemple usage de HashMap
 * @author kirsch
 */
public class IndexDepartment extends Department {

    HashMap<String, Employee> index;

    public IndexDepartment () {
        super();
        this.index = new HashMap();
    }

    public IndexDepartment (String name) {
        super(name);
        this.index = new HashMap();
    }

    public Employee getEmployee (String name) {
        Employee e = this.index.get(name);
        return e;
    }

    @Override
    public void addEmployee(Employee e) {
        //on élimine l'employé de la liste s'il y est déjà
        if (this.index.containsKey(e.getName())) {
            this.removeEmployee(e); //on utilise la méthode removeEmployee pour ne pas faire de copy-paste 
        }
        //ensuite on l'ajoute
        super.addEmployee(e);
        this.index.put(e.getName(), e);
    }

    @Override
    public void removeEmployee(Employee e) {
        super.removeEmployee(e);
        this.index.remove(e.getName());
    }    
    
    @Override
    public Iterator<Employee> employees () {
        return this.index.values().iterator();
    }
}
 