/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exceptions;

/**
 * illustration de construction et capture d'une exception
 * Objectif : exception, try-catch, inner-class
 * @author kirsch
 */
public class ExceptionDemo {
    public int factorial (int n) throws NegativeFactorialException {
        int f = 1;

        if (n < 0) {
            throw new NegativeFactorialException (n);
        }

        for (int i=1; i<=n; i++) {
            f *= i;
        }
        return f;
    }

    public static void toto() {
        int fa=0, fb=0;
        ExceptionDemo ed = new ExceptionDemo();

        try {
            fa = ed.factorial(2);
            System.out.println(fa);

            fa = ed.factorial(-4);
            fb = ed.factorial(3);   //jamais atteint
       }
        catch (NegativeFactorialException nfe) {
            System.out.println ("Exception! " + nfe.getMessage());
            nfe.printStackTrace(System.out);
        }
        

        System.out.println ("fa = " + fa + " fb = " + fb);
    }
    public static void main (String args[]) {
        toto();
    }
}

class NegativeFactorialException extends ArithmeticException {

    public NegativeFactorialException(String s) {
        super(s);
    }

    public NegativeFactorialException (int x) {
        super (new String("Factorial of " + x + " impossible"));
    }

    public NegativeFactorialException() {
    }
}