/*
 *  UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 *  MIAGE - UFR 27
 */
package review.exercices;

/**
 * Illustration de l'usage de la classe TableauObjetGenerique (et donc de
 * l'usage des génériques).
 *
 * @author kirsch
 */
public class MainTableauObjetGenerique {

    public static void afficher(TableauObjetGenerique<Integer> tab) {
        System.out.print("{ ");
        for (int i = 0; i < tab.size(); i++) {
            Integer o = tab.getCase(i);
            System.out.print(i + ":" + 
                    ((o != null)?o.toString():"--") + 
                    " ");            
        }
        System.out.println("}");
    }

    public static void remplir(TableauObjetGenerique<Integer> tab, int taille) {
        for (int i = 0; i < taille; i++) {
            tab.fillCase(i, i); //autoboxing: ça équivaut à new Integer(i)
        }
    }

    /**
     * pour illustrer, on va construire un tableau de n positions (n paramètre
     * en ligne de commande ou 5).
     */
    public static void main(String[] args) {
        int taille = 5;

        if (args.length > 0) {
            taille = Integer.parseInt(args[0]);
        }


        TableauObjetGenerique<Integer> tab = new TableauObjetGenerique<Integer>(taille);

        //sans le parametrage, le compilateur ne peut pas detecter les erreurs
        //TableauObjetGenerique tab = new TableauObjetGenerique(taille);        


        remplir(tab, taille);

        //desormais impossible !
        //tab.fillCase(2, new String("5"));

        afficher(tab);

        //pour le fin, on essaie de vider une case avant la fin du tableau
        if (taille > 1) {
            tab.clearCase(taille - 1);
            afficher(tab);
        }

    }
}
