/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices;

import review.business.Employee;

/**
 *
 * @author kirsch
 */
public class PileEmploye {

    private TextUI ui;
    
    private Pile<Employee> pileEmp;

    public PileEmploye() {
        this.ui = new TextUI();
        this.pileEmp = new MaPile<Employee>();
    }

    
    public TextUI getUi() {
        return ui;
    }

    public void setUi(TextUI ui) {
        this.ui = ui;
    }
    
    protected void readEmployee (Employee e) {
        e.setName(ui.readString("Name: "));
        e.setSalary(ui.readFloat("Salary: "));
        e.setHireDay(ui.readDate("Hire Year: ", "Hire month (1-12): ", "Hire day: "));
    }

    protected void printEmployee (Employee e) {
        ui.showMessage("Name: " + e.getName());
        ui.showMessage("Salary: " + e.getSalary());
        ui.showMessage("Hire date: " + e.getHireDay());
    }

    /** creer un nouveau employee et l'ajouter a la pile */
    public void newEmployee () {
        Employee e = new Employee();
        readEmployee(e);
        this.pileEmp.push(e);
    }

    /** on depile les employes de la pile et on les affiche */
    public void popEmployees () {
        while (!this.pileEmp.isEmpty()) {
            Employee e = this.pileEmp.pop();
            this.printEmployee(e);
        }
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        PileEmploye test = new PileEmploye();
        test.newEmployee();
        test.newEmployee();
        test.popEmployees();
    }

}
