/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.business;

import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JFrame;
import javax.swing.event.ListSelectionListener;

/**
 * Vue n'implémentant aucun listener, tout est dans le contrôleur de type
 * ListenerDepartmentControler.
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public abstract class AbstractNoListenerDepartmentView extends JFrame implements DepartmentView {
    ListenerDepartmentControler controler = null;
    
    public AbstractNoListenerDepartmentView() {
        controler = null;
        this.initWindowListener();
    }

    public AbstractNoListenerDepartmentView(ListenerDepartmentControler control) {
        this.controler = control;
        this.initWindowListener(); 
    }
    
    @Override
    public void setDepartmentControler(DepartmentControler control) {
        if (control == null) {
            this.setupListeners(controler, null);
            this.controler = null;
        }
        else if (control instanceof ListenerDepartmentControler) {
           this.setupListeners(controler, (ListenerDepartmentControler) control); 
           this.controler = (ListenerDepartmentControler) control; 
        }
    }
    
    public ListenerDepartmentControler getDepartmentControler() {
        return this.controler;
    }
    
    private void initWindowListener() {
        this.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                controler.closeAll();
            }
        });
    }

    /**
     * cette méthode doit abonner le nouveau contrôleur aux composants 
     * tout en désabonnant l'ancien à ces composants. 
     * @param oldone ancien contrôleur (peut être null)
     * @param newone nouveau contrôleur (peut être null)
     */
    protected abstract void setupListeners(
            ListenerDepartmentControler oldone, 
            ListenerDepartmentControler newone);
    protected abstract void initComponents();
    
}
