/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices.business;

import java.util.Iterator;
import javax.swing.event.EventListenerList;
import review.business.Department;
import review.business.Employee;
import review.business.IndexDepartment;

/**
 *
 * @author kirsch
 */
public class BasicDepartmentModel implements DepartmentModel {

    IndexDepartment dept;

    private EventListenerList listeners;

    public BasicDepartmentModel() {
        this.dept = new IndexDepartment();
        this.dept.setName("My Department");
        this.listeners = new EventListenerList();
    }

    public void addEmployee(Employee e) {
        this.dept.addEmployee(e);
        this.fireDepartmentChangedEvent();
    }

    public void removeEmployee(Employee e) {
        System.out.println("remove "+e.getName());
        this.dept.removeEmployee(e);
        this.fireDepartmentChangedEvent();
    }

    public Employee getEmployee(String name) {
        return this.dept.getEmployee(name);
    }

    public Iterator employees() {
        return this.dept.employees();
    }

    public void save() {  }

    public void load() {  }

     public Department getDepartment() {
        return dept;
    }
     
    
    /**
     * vérifie si l'employé indiqué existe dans le département
     * @param emp employé recherché
     * @return true si un employé avec le même nom est enregistré dans le dept,
     *         false sinon. 
     */
    public boolean exists (Employee emp) {
        boolean exts = (this.dept.getEmployee(emp.getName())!=null)?true:false;
        return exts;
    }
        


    public void addDepartmentListner(DepartmentListener l) {
        this.listeners.add(DepartmentListener.class, l);
    }

    public void removeDepartmentListener(DepartmentListener l) {
        this.listeners.remove(DepartmentListener.class, l);
    }

    public void fireDepartmentChangedEvent() {
        DepartmentListener[] listenersList =
                (DepartmentListener[]) 
                this.listeners.getListeners(DepartmentListener.class);
        
        
        for (DepartmentListener l: listenersList) {
            l.departmentChanged(new DepartmentChangedEvent(this));
        }
    }



}
