/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.business;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Calendar;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 *
 * @author kirsch
 */
public class FormEmployee extends AbstractDepartmentView {

    private JTextField nameText;
    private JTextField salaryText;
    private JTextField dayText;
    private JTextField monthText;
    private JTextField yearText;
    private JLabel status;
    private JButton okBtn;

    private int changesCount;

    public FormEmployee(DepartmentControler control) {
        super(control);
        initComponents();
        changesCount=0;
    }

    private void initComponents() {
        nameText = new JTextField();
        nameText.setColumns(35);
        salaryText = new JTextField();
        salaryText.setColumns(15);
        dayText = new JTextField();
        dayText.setColumns(2);
        monthText = new JTextField();
        monthText.setColumns(2);
        yearText = new JTextField();
        yearText.setColumns(4);
        status = new JLabel("Welcome!");

        okBtn = new JButton();
        okBtn.setText("Add Employee");
        okBtn.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                handleButtonClick();
            }
        });


        JPanel pcentre = new JPanel();
        pcentre.setLayout(new GridLayout(5,2));
        pcentre.add(new JLabel("Name: "));
        pcentre.add(this.nameText);
        pcentre.add(new JLabel("Salary: "));
        pcentre.add(this.salaryText);
        pcentre.add(new JLabel("Hire day: "));
        pcentre.add(this.dayText);
        pcentre.add(new JLabel("Hire month: "));
        pcentre.add(this.monthText);
        pcentre.add(new JLabel("Hire year: "));
        pcentre.add(this.yearText);
        
        this.add(pcentre, BorderLayout.CENTER);
        this.add(okBtn, BorderLayout.EAST);
        this.add(status, BorderLayout.SOUTH);

        pack();
    }

    private void handleButtonClick() {
        Calendar cal = Calendar.getInstance();
        try {
           cal.set(Integer.parseInt(this.yearText.getText()),
                   Integer.parseInt(this.monthText.getText()),
                   Integer.parseInt(this.dayText.getText()));
           float sal = Float.parseFloat(this.salaryText.getText());

           this.getDepartmentControler().notifyAddEmployee(this.nameText.getText(),
                   sal, cal.getTime());

        } catch (NumberFormatException nfe) {
            this.status.setText("Invalid salary or hire date");
        }
    }

    public void departmentChanged(DepartmentChangedEvent evt) {
        //ce formulaire ne fait qu'entrer des nouveaux employees
        //il ne montre pas le dept
        //donc, on ne fait que mettre a jour le label de status
        this.changesCount++;
        status.setText(this.changesCount+" changes ");
    }
}
