/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices.business;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Iterator;
import review.business.Department;
import review.business.Employee;

/**
 *
 * @author kirsch
 */
public class SerializedDepartmentModel extends BasicDepartmentModel {

    private String filename;
    public static final String DEFAULT_FILE_NAME = "DepartementModel.dat";

    public SerializedDepartmentModel() {
        super();
        this.filename = DEFAULT_FILE_NAME;
    }

    public SerializedDepartmentModel(String file) {
        super();
        this.filename = file;
    }

    public void save() {
        ObjectOutputStream out;
        try {
            out = new ObjectOutputStream(new FileOutputStream(this.filename));
            out.writeObject(this.getDepartment());
        } catch (IOException ex) {
            //ICI ON DEVRAIT LANCER UNE EXCEPTION POUR AVERTIR LES AUTRES ELEMENTS,
            //ET NOTAMMENT LES VUES, QU'IL Y A EU UN SOUCI, AFIN QU'UN MESSAGE D'ERREUR
            //SOIT PRESENTER A L'UTILSATEUR
            ex.printStackTrace();
        }
    }

    @Override
    public void load() {
        ObjectInputStream in;
        try {
            in = new ObjectInputStream(new FileInputStream(this.filename));
            Department d = (Department) in.readObject();
            this.loadEmployee(d);
            this.loadDeptInfo(d);
        } catch (ClassNotFoundException ex) {
            //ICI ON DEVRAIT LANCER UNE EXCEPTION POUR AVERTIR LES AUTRES ELEMENTS,
            //ET NOTAMMENT LES VUES, QU'IL Y A EU UN SOUCI, AFIN QU'UN MESSAGE D'ERREUR
            //ADAPTE SOIT PRESENTER A L'UTILSATEUR
            //throw new DepartmentModelException ("ClassNotFound");
            ex.printStackTrace();

        } catch (IOException ex) {
            //ICI ON DEVRAIT LANCER UNE EXCEPTION POUR AVERTIR LES AUTRES ELEMENTS,
            //ET NOTAMMENT LES VUES, QU'IL Y A EU UN SOUCI, AFIN QU'UN MESSAGE D'ERREUR
            //ADAPTE SOIT PRESENTER A L'UTILSATEUR
            //throw new DepartmentModelException ("IOException");
            ex.printStackTrace();

        }
    }


    /**
     * integre les employee d'un department d au department courant
     * @param d source des nouveaux employes
     */
    protected void loadEmployee (Department d) {
        Iterator<Employee> it = d.employees();
        while (it.hasNext())
            this.addEmployee(it.next());
    }

    /**
     * integre les informations relatives a un department d (name et manager)
     * au department courant
     * @param d source des informations a importer
     */
    protected void loadDeptInfo (Department d) {
        this.dept.setName(d.getName());
        this.dept.setManager(d.getManager());
    }

}
