/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.heritage;

/**
 * exemple de classe abstraite
 * Si on observe les classes MyDoor et MetalDoor ont beaucoup en commun,
 * notamment la gestion de l'état qui est la même entre les deux.
 * On peut donc extraire un comportement commun à toutes les implémentations de 
 * l'interface Door.
 * @author kirsch
 */
public abstract class AbstractDoor implements Door {
    private static final boolean opened = false;
    private static final boolean closed = true;
    
    private boolean state = closed;
    
    @Override
    public int getState() {
        return (state==closed)?Door.CLOSED:Door.OPEN;
    }

    @Override
    public void setState(int state) {
        this.state = (state == Door.OPEN)?opened:closed;
    }

    /* pas de méthode open() ni close() */
}
