/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.heritage;

/**
 * Classe illustrant l'usage des interface pour réduire le couplage
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class MainDoor {

    public static void main(String[] args) {
        Door mydoor, metaldoor;
        ControlDevice control;
        
        mydoor = new MyDoor();
        metaldoor = new MetalDoor();
        control = new ControlDevice();
        
        //l'objet control peut fonctionne aussi bien  ...
        //... avec une porte MyDoor
        control.setDoor(mydoor);
        control.pressButtonA();
        System.out.println(control.getDoor().getClass() + " : "+ control.getDoor().getState());
        //...qu'avec une porte MetalDoor
        control.setDoor(metaldoor);
        control.pressButtonA();
        System.out.println(control.getDoor().getClass() + " : "+ control.getDoor().getState());
        
    }
}
