/*
 UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 MIAGE - UFR 27
 Cours ISI5 / INF2 - Developpement d'Interface

 */

package review.ihm.layouts;

import java.awt.Frame;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;


/**
 * ceci est un frame qui contient plusieurs (5) boutons
 * ce frame est utilise pour monter l'usage du flowlayout manager
 * @author kirsch
 */
public class FlowLayoutExampleFrame extends Frame {

    public FlowLayoutExampleFrame(String title) {
        super(title);
        initComponents();
        this.addWindowListener(new ExternalWindowListner ());
    }
    
    @Override
   public void setSize(Dimension d) {
       if (d.getWidth()>=100 && d.getHeight()>=100)
           super.setSize(d);
   } 

    protected void initComponents () {

        /* on definit le layoutmanager centralise, avec 2x plus de espace
        vertical et horizontal entre les composants */
        FlowLayout flow = new FlowLayout(FlowLayout.CENTER);
        flow.setHgap(flow.getHgap() * 2);
        flow.setVgap(flow.getVgap() * 2);

        this.setLayout(flow);

        //on ajoute 5 boutons
        for (int i=1; i<=5; i++) {
            Button b = new Button("Button "+i);
            this.add(b);
        }
        this.setSize(this.guessSize());
    }
    
   /**
    * cette methode calcule une taille pour le frame en fonction
    * de l'ecran (1/4)
    * @return Dimension representant 1/4 de l'ecran
    */
    protected Dimension guessSize () {
        Dimension d = null;

        //on recupere un lien vers le gestionnaire
        Toolkit kit = Toolkit.getDefaultToolkit();
        d = kit.getScreenSize();

        double wdt = d.getWidth() / 4;
        double hgt = d.getHeight() / 4;

        //taille mminimale WIDTH, HEIGHT
        if (wdt < WIDTH) wdt = WIDTH;
        if (hgt < HEIGHT) hgt = HEIGHT;

        d.setSize(wdt, hgt);
        
        return (d);
    }

    public static void main(String[] args) {
        FlowLayoutExampleFrame frame = new FlowLayoutExampleFrame ("FlowManager");
        frame.setVisible(true);
        frame.pack();
    }

   static final int WIDTH = 300;
   static final int HEIGHT = 200;

}
