/*
UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
MIAGE - UFR 27
Cours ISI5 / INF2 - Developpement d'Interface

 */
package review.ihm.volumeapplication;

/**
 * Example d'usage du modele MVC
 * Cette classe definit un evennement de modification de l'etat du modele.
 * Un objet VolumeChangedEvent indique que le modele (indicant un volume)
 * a ete modifie.
 *
 * Example base sur Baptiste Wicht, <b>"Implémentation du pattern MVC"</b>,
 * 24 Avril 2007 (derniere visite le 29 Janvier 2009).
 * @see http://baptiste-wicht.developpez.com/tutoriel/conception/mvc/
 * @author kirsch
 */
class VolumeChangedEvent extends java.util.EventObject {

    public VolumeChangedEvent(Object source, int newVolume) {
        super(source);
        this.newVolume = newVolume;
    }

    public int getNewVolume() {
        return newVolume;
    }

    private int newVolume;
}
