/*
 UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 MIAGE - UFR 27
 Cours ISI5 / INF2 - Developpement d'Interface

 */

package review.ihm.volumeapplication;

import java.awt.Dimension;

/**
 * Example d'usage du modele MVC
 * Cette classe definit le view pour modele de volume.
 *
 * Example base sur Baptiste Wicht, <b>"Implémentation du pattern MVC"</b>,
 * 24 Avril 2007 (derniere visite le 29 Janvier 2009).
 * @see http://baptiste-wicht.developpez.com/tutoriel/conception/mvc/
 * @author kirsch
 */
public abstract class VolumeView implements VolumeModelListener {

    public VolumeView(VolumeController controller) {
        this.controller = controller;
        this.controller.addView(this);
    }
    
    public final VolumeController getController(){
		return controller;
	}

	
    public abstract void display();
	public abstract void close();
    public abstract void setLocation(int x, int y);
    public abstract void setSize(Dimension d);
    public abstract Dimension getSize();
    

    private VolumeController controller = null;
}
