/*
UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
MIAGE - UFR 27
Cours ISI5 / INF2 - Developpement d'Interface

 */
package review.jdbc;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author kirsch
 */
public class DicoBase {
    private String driver;
    private String bdd;
    private String login;
    private String pass;
    private Connection conn;

    public DicoBase() {
        //on peut lire ces informations sur des proprietes
        driver = "org.apache.derby.jdbc.ClientDriver";
        bdd = "jdbc:derby://localhost:1527/Dictionnaire";
        login = "dico";
        pass = "dico";
        conn = null;
    }

    public boolean connectDB() {
        boolean ok = false;
        try {
            //Charge le pilote
            Class.forName(driver);
            //Crée la connection
            conn = DriverManager.getConnection(bdd, login, pass);
            System.out.println("Connexion à la BDD");
            ok = true;
        } catch (ClassNotFoundException cnfe) {
            Logger.getLogger(DicoBase.class.getName()).
                    log(Level.SEVERE, "Driver inconnu ", cnfe);
        } catch (SQLException sqle) {
            Logger.getLogger(DicoBase.class.getName()).
                    log(Level.SEVERE, "Connexion au driver impossible", sqle);
        }
        return (ok);
    }

    public void closeDB() {
        if (conn != null) {
            try {
                conn.close();
                System.out.println("Cloture de la connexion à la BDD");
            } catch (SQLException ex) {
                Logger.getLogger(DicoBase.class.getName()).
                        log(Level.SEVERE, "Erreur de cloture: ", ex);
            }
        }
    }

    public ArrayList<String> getWords() {
        ArrayList<String> words = new ArrayList();
        String sql = "SELECT * FROM DICO.FR";

        try {
            Statement stat = conn.createStatement();
            ResultSet rs = stat.executeQuery(sql);

            while (rs.next()) {
                String aWord = rs.getString("Word");
                words.add(aWord);
            }
        } catch (SQLException ex) {
            Logger.getLogger(DicoBase.class.getName()).log(Level.SEVERE, null, ex);
        }
        return words;
    }

    public int getLastId () {
        int lastId = -1;
        String sql = "SELECT Id FROM DICO.FR";

        try {
            Statement stat = conn.createStatement();
            ResultSet rs = stat.executeQuery(sql);

            while (rs.next()) {
                int id = rs.getInt("Id");
                if (id>lastId)
                    lastId = id;
            }

        } catch (SQLException ex) {
            Logger.getLogger(DicoBase.class.getName()).log(Level.SEVERE, null, ex);
        }        
        return lastId;
    }

    public int insertWord (int id, String word) {
        int rows = -1;
        String pattern = "INSERT INTO DICO.FR (Id, Word) VALUES ({0}, ''{1}'')";
        String sql = MessageFormat.format(pattern, id, word);
        System.out.println (sql);

        try {
            Statement stat = conn.createStatement();
            rows = stat.executeUpdate(sql);
        } catch (SQLException ex) {
            Logger.getLogger(DicoBase.class.getName()).log(Level.SEVERE, null, ex);
        }
        return rows;
    }
}
