/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.patterns.composite;

/**
 * Application pour illustrer le comportement du pattern Composite
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class CompositeMain {

    public static Component buildLeaf(String name) {
        Leaf l = new Leaf();
        l.setName(name);
        l.setPrix(10);
        return l;
    }
    
    public static Component buildComposite(String name, Component[] objs) {
        Composite c = new Composite();
        c.setName(name);
        for (Component l: objs) c.add(l);
        return c;
    }
    
    public static Component buildTree() {
        Component D =  buildLeaf("D");
        Component E =  buildLeaf("E");
        Component C =  buildLeaf("C");
        
        Component[] DE = { D, E };
        Component B = buildComposite("B", DE);
        
        Component[] BC = { B, C };
        Component A = buildComposite("A", BC);
        
        return A;
    }
    
    public static void main(String[] args) {
        Component[] leafs = new Component[2];
        Component c1, c2, racine;
        Client client;
        
        for (int i=0; i<2; i++) 
            leafs[i] = buildLeaf("Leaf 1."+i);
        c1 = buildComposite("Noeud 1", leafs);
        
        for (int i=0; i<2; i++) 
            leafs[i] = buildLeaf("Leaf 2."+i);
        c2 = buildComposite("Noeud 2", leafs);

        leafs[0] = c1;
        leafs[1] = c2;
        racine = buildComposite("Racine",leafs);
        
        
        
        client = new Client();
        
        racine = buildTree();
        //le traitement est totalement transparent
        //on peut même remplacer le composite par une feille à la racine
        //racine = buildLeaf("C");
        
        client.setComponent(racine);
        client.doSomething();
    }
}
