/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.structures;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

/**
 * Exemple usage des listes
 * @author kirsch
 */
public class HelloLists {
    ArrayList<String> first;

    public HelloLists() {
        this.first = new ArrayList<String>();
    }

    public void setList(String list[]) {
         for (String s: list) {
             this.first.add(s);
         }
    }

    /**
     * Copie la liste en ordre inverse.
     * Exemple d'usage des iterateur Iterator et ListIterator.
     * @return List liste en ordre inverse
     */
    public List copyInverse() {
        LinkedList<String> second = new LinkedList<String>();
        ListIterator<String> lIter = second.listIterator();
        Iterator<String> iter = this.first.iterator();

        while (iter.hasNext()) {
            lIter.add(iter.next());
            lIter.previous();
        }
        return (second);
    }

/* Une autre manière de réaliser la copie inversée serait 
 * de toujours insérer les  valeurs à la position 0 de la nouvelle liste.
 * Mais c'est moins drôle, on ne verrait pas alors l'usage de ListIterator ;-)
 * 
   public List copy2 () {
        ArrayList<String> nl = new ArrayList<String>();
        Iterator<String> it = this.first.iterator();

        while (it.hasNext()) {
            String s = it.next();
            nl.add(0, s);
        }

        return nl;
    }
    *
    */

    public void print(List<String> list) {
        Iterator iter = list.iterator();
        while (iter.hasNext()) {
            System.out.print (iter.next() + " ");
        }
        System.out.println();
    }
    
    public void print () {
        this.print(this.first);
    }

    public static void main(String[] args) {
        String apha[] = {"a", "b", "c", "d"};
        HelloLists hello = new HelloLists();

        hello.setList(apha);
        hello.print();

        List list = (List) hello.copyInverse();
        hello.print(list);

        //List l2 = hello.copy2();
        //hello.print(l2);
    }
}
