/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */
package review.exercices;

import org.junit.After;
import org.junit.AfterClass;
import static org.junit.Assert.*;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

/**
 *
 * @author Manuele Kirsch Pinheiro <kirschpm@gmail.com>
 */
public class FactorialTest {
  
    int normal = 4;
    int fnormal = 24;
    int grand = 10;
    int fgrand = 3628800;
    int negatif = -1;

    public FactorialTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
        System.out.println("Setting up test Factorial");
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
        System.out.println("Closing test Factorial");
    }

    @Before
    public void setUp() {
        normal = 4;
        fnormal = 24;
        grand = 10;
        fgrand = 3628800;
        negatif = -1;
    }

    @After
    public void tearDown() {
    }

    /**
     * Teste méthode factorial avec n=0
     */
    @Test
    public void testFactorialZero() {
        System.out.println("factorial zero");
        int n = 0;
        int expResult = 0;
        int result = Factorial.factorial(n);
        assertEquals(expResult, result);
    }
    
    @Test
    public void testFactorialNormal() {
        System.out.println("factorial normal");
        int result = Factorial.factorial(normal);
        assertEquals(fnormal, result);
    }
    
    @Test 
    public void testFactorialGrand() {
        System.out.println("factorial grand");
        int result = Factorial.factorial(grand);
        assertEquals(fgrand, result);
    }
    
    @Test (expected = NegativeFactorialException.class)
    public void testFactorialNegatif() {
        System.out.println("factorial negatif");
        int result = Factorial.factorial(negatif);
        assertEquals(negatif, result);
    }
    
    @Test (timeout = 500)
    public void testFactorialTresGrand() {
        System.out.println("factorial tres grand");
        int n = grand+5;
        int ftgde = Factorial.factorial(n);
        int fgde = Factorial.factorial(n-1);
        assertTrue((ftgde/n)==fgde); // n!/n doit etre egal a n!
    }
}
